// autogenerated by syzkaller (https://github.com/google/syzkaller)

#define _GNU_SOURCE 

#include <dirent.h>
#include <endian.h>
#include <errno.h>
#include <fcntl.h>
#include <signal.h>
#include <stdint.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/prctl.h>
#include <sys/stat.h>
#include <sys/syscall.h>
#include <sys/types.h>
#include <sys/wait.h>
#include <time.h>
#include <unistd.h>

unsigned long long procid;

static void sleep_ms(uint64_t ms)
{
	usleep(ms * 1000);
}

static uint64_t current_time_ms(void)
{
	struct timespec ts;
	if (clock_gettime(CLOCK_MONOTONIC, &ts))
	exit(1);
	return (uint64_t)ts.tv_sec * 1000 + (uint64_t)ts.tv_nsec / 1000000;
}

#define BITMASK(bf_off,bf_len) (((1ull << (bf_len)) - 1) << (bf_off))
#define STORE_BY_BITMASK(type,htobe,addr,val,bf_off,bf_len) *(type*)(addr) = htobe((htobe(*(type*)(addr)) & ~BITMASK((bf_off), (bf_len))) | (((type)(val) << (bf_off)) & BITMASK((bf_off), (bf_len))))

static void kill_and_wait(int pid, int* status)
{
	kill(-pid, SIGKILL);
	kill(pid, SIGKILL);
	int i;
	for (i = 0; i < 100; i++) {
		if (waitpid(-1, status, WNOHANG | __WALL) == pid)
			return;
		usleep(1000);
	}
	DIR* dir = opendir("/sys/fs/fuse/connections");
	if (dir) {
		for (;;) {
			struct dirent* ent = readdir(dir);
			if (!ent)
				break;
			if (strcmp(ent->d_name, ".") == 0 || strcmp(ent->d_name, "..") == 0)
				continue;
			char abort[300];
			snprintf(abort, sizeof(abort), "/sys/fs/fuse/connections/%s/abort", ent->d_name);
			int fd = open(abort, O_WRONLY);
			if (fd == -1) {
				continue;
			}
			if (write(fd, abort, 1) < 0) {
			}
			close(fd);
		}
		closedir(dir);
	} else {
	}
	while (waitpid(-1, status, __WALL) != pid) {
	}
}

#define SYZ_HAVE_SETUP_TEST 1
static void setup_test()
{
	prctl(PR_SET_PDEATHSIG, SIGKILL, 0, 0, 0);
	setpgrp();
}

#define SYZ_HAVE_RESET_TEST 1
static void reset_test()
{
	int fd;
	for (fd = 3; fd < 30; fd++)
		close(fd);
}

static void execute_one(void);

#define WAIT_FLAGS __WALL

static void loop(void)
{
	int iter;
	for (iter = 0;; iter++) {
		int pid = fork();
		if (pid < 0)
	exit(1);
		if (pid == 0) {
			setup_test();
			execute_one();
			reset_test();
			exit(0);
		}
		int status = 0;
		uint64_t start = current_time_ms();
		for (;;) {
			if (waitpid(-1, &status, WNOHANG | WAIT_FLAGS) == pid)
				break;
			sleep_ms(1);
			if (current_time_ms() - start < 5 * 1000)
				continue;
			kill_and_wait(pid, &status);
			break;
		}
	}
}

void execute_one(void)
{
*(uint32_t*)0x20000300 = 0;
*(uint32_t*)0x20000304 = 0x70;
*(uint8_t*)0x20000308 = 0;
*(uint8_t*)0x20000309 = 0;
*(uint8_t*)0x2000030a = 0;
*(uint8_t*)0x2000030b = 0;
*(uint32_t*)0x2000030c = 0;
*(uint64_t*)0x20000310 = 0x4000;
*(uint64_t*)0x20000318 = 0x22;
*(uint64_t*)0x20000320 = 0;
STORE_BY_BITMASK(uint64_t, , 0x20000328, 0, 0, 1);
STORE_BY_BITMASK(uint64_t, , 0x20000328, 0, 1, 1);
STORE_BY_BITMASK(uint64_t, , 0x20000328, 0, 2, 1);
STORE_BY_BITMASK(uint64_t, , 0x20000328, 0, 3, 1);
STORE_BY_BITMASK(uint64_t, , 0x20000328, 0, 4, 1);
STORE_BY_BITMASK(uint64_t, , 0x20000328, 0, 5, 1);
STORE_BY_BITMASK(uint64_t, , 0x20000328, 0, 6, 1);
STORE_BY_BITMASK(uint64_t, , 0x20000328, 0, 7, 1);
STORE_BY_BITMASK(uint64_t, , 0x20000328, 0, 8, 1);
STORE_BY_BITMASK(uint64_t, , 0x20000328, 0, 9, 1);
STORE_BY_BITMASK(uint64_t, , 0x20000328, 0, 10, 1);
STORE_BY_BITMASK(uint64_t, , 0x20000328, 0, 11, 1);
STORE_BY_BITMASK(uint64_t, , 0x20000328, 0, 12, 1);
STORE_BY_BITMASK(uint64_t, , 0x20000328, 0, 13, 1);
STORE_BY_BITMASK(uint64_t, , 0x20000328, 0, 14, 1);
STORE_BY_BITMASK(uint64_t, , 0x20000328, 0, 15, 2);
STORE_BY_BITMASK(uint64_t, , 0x20000328, 0, 17, 1);
STORE_BY_BITMASK(uint64_t, , 0x20000328, 0, 18, 1);
STORE_BY_BITMASK(uint64_t, , 0x20000328, 0, 19, 1);
STORE_BY_BITMASK(uint64_t, , 0x20000328, 3, 20, 1);
STORE_BY_BITMASK(uint64_t, , 0x20000328, 0, 21, 1);
STORE_BY_BITMASK(uint64_t, , 0x20000328, 0, 22, 1);
STORE_BY_BITMASK(uint64_t, , 0x20000328, 0, 23, 1);
STORE_BY_BITMASK(uint64_t, , 0x20000328, 0, 24, 1);
STORE_BY_BITMASK(uint64_t, , 0x20000328, 0, 25, 1);
STORE_BY_BITMASK(uint64_t, , 0x20000328, 0, 26, 1);
STORE_BY_BITMASK(uint64_t, , 0x20000328, 0x80000, 27, 1);
STORE_BY_BITMASK(uint64_t, , 0x20000328, 0, 28, 1);
STORE_BY_BITMASK(uint64_t, , 0x20000328, 0, 29, 35);
*(uint32_t*)0x20000330 = 0;
*(uint32_t*)0x20000334 = 0;
*(uint64_t*)0x20000338 = 0;
*(uint64_t*)0x20000340 = 0;
*(uint64_t*)0x20000348 = 0;
*(uint64_t*)0x20000350 = 0;
*(uint32_t*)0x20000358 = 0;
*(uint32_t*)0x2000035c = 0;
*(uint64_t*)0x20000360 = 0;
*(uint32_t*)0x20000368 = 0;
*(uint16_t*)0x2000036c = 0;
*(uint16_t*)0x2000036e = 0;
	syscall(__NR_perf_event_open, 0x20000300, 0, 0, -1, 0);

}
int main(void)
{
		syscall(__NR_mmap, 0x20000000, 0x1000000, 3, 0x32, -1, 0);
	for (procid = 0; procid < 8; procid++) {
		if (fork() == 0) {
			loop();
		}
	}
	sleep(1000000);
	return 0;
}
